
AC_DEFUN(LAC_GRAM_ARGS,
[

AC_ARG_ENABLE(gram-client,
        [  --disable-gram-client         don't configure GRAM client library],
        [lac_enable_gram_client="$enableval"],
        [lac_enable_gram_client="yes"])

AC_ARG_ENABLE(gram-rsl,
        [  --disable-gram-rsl            don't configure GRAM resource spec language library],
        [lac_enable_gram_rsl="$enableval"],
        [lac_enable_gram_rsl="yes"])

AC_ARG_ENABLE(gram-myjob,
        [  --disable-gram-myjob          don't configure GRAM myjob library],
        [lac_enable_gram_myjob="$enableval"],
        [lac_enable_gram_myjob="yes"])

AC_ARG_ENABLE(gram-gatekeeper,
        [  --disable-gram-gatekeeper     don't configure GRAM gatekeeper],
        [lac_enable_gram_gatekeeper="$enableval"],
        [lac_enable_gram_gatekeeper="yes"])

AC_ARG_WITH(gram-job-manager,
	[  --with-gram-job-manager       GRAM job manager: condor, easymcs, lsf, loadleveler, or fork [fork]],
	[if test "$withval" = "yes" ; then
	     lac_gram_jm_type="fork"
         else
             lac_gram_jm_type="$withval"
         fi
        ],
	[lac_gram_jm_type="fork"])

AC_ARG_ENABLE(gram-test,
        [  --disable-gram-test           don't configure GRAM test],
        [lac_enable_gram_test="$enableval"],
        [lac_enable_gram_test="yes"])

])

AC_DEFUN(LAC_GRAM_MYJOB,
[
    if test "$lac_mpl" = "yes" ; then
        GRAM_MYJOB_SHARED_PROTO_OBJS="gram_myjob_mpl.\$(OFILE)"
    elif test "$lac_mpi" = "yes" ; then
        GRAM_MYJOB_SHARED_PROTO_OBJS="gram_myjob_mpi.\$(OFILE)"
    else
        case "$target" in
            i860-intel-osf* )
                GRAM_MYJOB_SHARED_PROTO_OBJS="gram_myjob_inx.\$(OFILE)"
	    ;;

	    * )
                GRAM_MYJOB_SHARED_PROTO_OBJS="gram_myjob_none.\$(OFILE)"
	    ;;		
	esac
    fi
    AC_SUBST(GRAM_MYJOB_SHARED_PROTO_OBJS)
])

AC_DEFUN(LAC_GRAM,
[
    LAC_GRAM_ARGS

    case "$lac_gram_jm_type" in
        condor )
            GRAM_JM_METHOD=grami_jm_shell
            GRAM_JM_SHELL_TYPE=condor
            GRAM_JM_SHELL_DEFINE=-DGRAMI_CONDOR_MANAGER
        ;;
        easymcs )
            GRAM_JM_METHOD=grami_jm_shell
            GRAM_JM_SHELL_TYPE=easymcs
            GRAM_JM_SHELL_DEFINE=-DGRAMI_EASYMCS_MANAGER
        ;;
        loadleveler )
            GRAM_JM_METHOD=grami_jm_shell
            GRAM_JM_SHELL_TYPE=loadleveler
            GRAM_JM_SHELL_DEFINE=-DGRAMI_LOADLEVELER_MANAGER
        ;;
        t3e_nqe )
            GRAM_JM_METHOD=grami_jm_shell
            GRAM_JM_SHELL_TYPE=t3e_nqe
            GRAM_JM_SHELL_DEFINE=-DGRAMI_T3E_NQE_MANAGER
        ;;
        lsf )
            GRAM_JM_METHOD=grami_jm_lsf
            GRAM_JM_SHELL_TYPE=none
            GRAM_JM_SHELL_DEFINE=
        ;;
        fork )
            GRAM_JM_METHOD=grami_jm_simple_fork
            GRAM_JM_SHELL_TYPE=none
            GRAM_JM_SHELL_DEFINE=
        ;;
        fake )
            GRAM_JM_METHOD=grami_jm_fake
            GRAM_JM_SHELL_TYPE=none
            GRAM_JM_SHELL_DEFINE=
        ;;
	no )
	;;
        * )
            AC_MSG_ERROR([Invalid --with-gram-job-manager value: $lac_gram_jm_type])
        ;;
    esac
    
    GRAM_JM_TYPE=$lac_gram_jm_type

    AC_SUBST(GRAM_JM_TYPE)
    AC_SUBST(GRAM_JM_METHOD)
    AC_SUBST(GRAM_JM_SHELL_TYPE)
    AC_SUBST(GRAM_JM_SHELL_DEFINE)

])


AC_DEFUN(LAC_LSF_DIR,
[

  if test -d $1 ; then
    LSF_DIRS="$LSF_DIRS $2 $1"
  fi
])
