dnl -----------------------------------------------------------------
dnl -- Start of a TOPOLOGYD specific configuration file
dnl --
dnl --
dnl -----------------------------------------------------------------



AC_DEFUN(LAC_TOPD_ARGS,
[

AC_CACHE_CHECK(topologyd client port, topd_client_port, [dnl
AC_ARG_WITH(topd_client_port,
	[  --with-topd-client-port=value           Client port number for the local topologyd host],
	[topd_client_port="$withval"],
	[topd_client_port="9000"])
])
AC_SUBST(topd_client_port)


AC_CACHE_CHECK(topologyd data port, topd_data_port, [dnl
AC_ARG_WITH(topd_data_port,
	[  --with-topd-data-port=value           Data port number for the local topologyd host],
	[topd_data_port="$withval"],
	[topd_data_port="9001"])
])
AC_SUBST(topd_data_port)


AC_CACHE_CHECK(topologyd master site, topd_master_site, [dnl
AC_ARG_WITH(topd_master_site,
	[  --with-topd-master-site=value           Master site for the group],
	[topd_master_site="$withval"],
	[topd_master_site="www.globus.org"])
])
AC_SUBST(topd_master_site)


AC_CACHE_CHECK(topologyd master client port, topd_master_client_port, [dnl
AC_ARG_WITH(topd_master_client_port,
	[  --with-topd-master-client-port=value           Master client port],
	[topd_master_client_port="$withval"],
	[topd_master_client_port="9000"])
])
AC_SUBST(topd_master_client_port)


AC_CACHE_CHECK(topologyd master data port, topd_master_data_port, [dnl
AC_ARG_WITH(topd_master_data_port,
	[  --with-topd-master-data-port=value           Master data port],
	[topd_master_data_port="$withval"],
	[topd_master_data_port="9001"])
])
AC_SUBST(topd_master_data_port)

AC_CACHE_CHECK(topologyd group name, topd_group_name, [dnl
AC_ARG_WITH(topd_group_name,
	[  --with-topd-group-name=value           Group name for topologyd],
	[topd_group_name="$withval"],
	[topd_group_name="Globus-Topologyd"])
])
AC_SUBST(topd_group_name)

AC_CACHE_CHECK(topologyd mds update period, topd_mds_update_period, [dnl
AC_ARG_WITH(topd_mds_update_period,
	[  --with-topd-mds-update-period=value           MDS update period for topologyd],
	[topd_mds_update_period="$withval"],
	[topd_mds_update_period="600"])
])
AC_SUBST(topd_mds_update_period)

])

AC_DEFUN(LAC_TOPD_PROGS,
[

AC_PATH_PROGS(LN, ln, cp)

])


AC_DEFUN(LAC_TOPD_COMP_OPTIONS,
[

dnl NO -64 if its an IRIX

case "$target" in
  mips-sgi-irix6* )       PLATFORMCFLAGS="-DUSE_WAITPID"  
        CFLAGS="`echo $CFLAGS | sed -e 's/-64//'` -n32"
        LDFLAGS="`echo $LDFLAGS | sed -e 's/-64//'` -n32"
    ;;
esac

PLATFORMCFLAGS="$PLATFORMCFLAGS $CFLAGS"
PLATFORMLDFLAGS="$LDFLAGS"

AC_SUBST(PLATFORMCFLAGS)
AC_SUBST(PLATFORMLDFLAGS)

])


AC_DEFUN(LAC_TOPD,
[

LAC_TOPD_ARGS
LAC_TOPD_PROGS
LAC_TOPD_COMP_OPTIONS

])


