/*
************************************************************************
**                                                                    **
**  hbm.h - include file for heartbeat monitor and clients            **
**                                                                    **
************************************************************************
*/
#ifndef HBM_H
#define HBM_H

#include "hbm_codes.h"
#include "hbm_config.h"

#include "hbm_sys_headers.h"

#include "hbm_defaults.h"

#ifndef HAVE_UTCTIME
typedef time_t  UTCtime;
#endif

#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN                  256
#endif

#ifdef DEBUG_MSGS
#define DEBUGF1(x)      fprintf(stderr,(x))
#define DEBUGF2(x,y)    fprintf(stderr,(x),(y))
#define DEBUGF3(x,y,z)  fprintf(stderr,(x),(y),(z))
#else
#define DEBUGF1(x)
#define DEBUGF2(x,y)
#define DEBUGF3(x,y,z)
#endif

/*
 * PackUInt32(unsigned char Array[4], unsigned long I)
 *
 * Pack the unsigned long I into the 4 byte unsigned
 * character Array in 32-bit, big-endian format.
 */
#define PackUInt32(Array, I) \
{ \
    (Array)[0] = (unsigned char) (((unsigned long)(I) & 0xFF000000) >> 24); \
    (Array)[1] = (unsigned char) (((unsigned long)(I) & 0xFF0000) >> 16); \
    (Array)[2] = (unsigned char) (((unsigned long)(I) & 0xFF00) >> 8); \
    (Array)[3] = (unsigned char)  ((unsigned long)(I) & 0xFF); \
}

/*
 * UnpackUInt32(unsigned char Array[4], unsigned long I)
 *
 * Unpack the 32-bit, big-endian unsigned value from the
 * 4 byte character Array into the unsigned long I.
 */
#define UnpackUInt32(Array, I) \
{ \
    (I) = (  ( ((unsigned long) (unsigned char)(Array)[0]) << 24) \
           | ( ((unsigned long) (unsigned char)(Array)[1]) << 16) \
           | ( ((unsigned long) (unsigned char)(Array)[2]) << 8) \
           |   ((unsigned long) (unsigned char)(Array)[3]) ); \
}

#endif /* not defined HBM_H */
/*
************************************************************************
**                                                                    **
**  hbm.h - end                                                       **
**                                                                    **
************************************************************************
*/
