/*
************************************************************************
**  Example GUSTO Heartbeat Client                                    **
************************************************************************
*/

/*
************************************************************************
**  Include the include file hbm_client.h                             **
************************************************************************
*/
#include "hbm_client.h"
/*
************************************************************************
**  Include the include file hbm_client.h (above)                     **
************************************************************************
*/

#include <stdio.h>
#include <unistd.h>
#include <sys/time.h>

main(   argc,
        argv)
    int     argc;
    char   *argv[];
{
    int     retcd;

    int     temp;

    int     count = 0;

    int     array_idx,
            array_idx_max = 1023;

    int     array_wk[1024];

    struct timeval  time_curr,
                    time_end;

    time_curr.tv_sec = 0;
    gettimeofday(&time_curr, NULL);
    time_end.tv_sec = time_curr.tv_sec + 120;

    fprintf(stderr, "registerring\n");
/*
************************************************************************
**  Include the following code to register with the                   **
**  heartbeat monitor.                                                **
**                                                                    **
**  Definition of hbm_register is as follows:                         **
**                                                                    **
**  int  hbm_register(pgm_name)                                       **
**                                                                    **
**  Parameters:                                                       **
**      char  *procname - pointer to char,                            **
**                        (command line fields:                       **
**                            program name and parameters)            **
**                        program name is used when generating        **
**                        error messages.                             **
**                        (Error messages have format:                **
**                            "<pgm name>: HBM: <error description>"  **
**      unsigned int                                                  **
**            flags     - Logical OR of 0 with the following flags    **
**                        as appropriate (i.e., parms passed in,      **
**                        normally not used)                          **
**                        flags are:    HBM_CLFLAG_SET_CL_PID         **
**                                      HBM_CLFLAG_SET_CL_RPTNAME     **
**                                      HBM_CLFLAG_SET_DC_HOST        **
**                                      HBM_CLFLAG_SET_DC_PORT        **
**      struct hbm_parms                                              **
**            hbm_info  - struct with four fields to be used if       **
**                        corresponding flag is set:                  **
**                            int     cl_pid                          **
**                            char   *cl_procname_rpt                 **
**                            char   *dc_hostname                     **
**                            int     dc_port                         **
**                                                                    **
**          field usage is as follows:                                **
**              cl_pid:          pid of (different) process to        **
**                               register                             **
**              cl_procname_rpt: name to be used by the Local Monitor **
**                               when reporting to the Data Collector **
**              dc_hostname:     name of the host where the           **
**                               Data Collector resides               **
**              dc_port:         the port used by the Data Collector  **
**                               for receiving heartbeat messages     **
**                                                                    **
**  Returned values:                                                  **
**      hbm_register() returns an integer return code.                **
**          Successful completion:   = 0.                             **
**          Unsuccessful completion: < 0.                             **
**                                                                    **
**  Operation:                                                        **
**      hbm_register()  reads the file hbc_parms to get the           **
**      Port number to use for registering with the local monitor     **
**      and the IP address and Port number the local monitor is to    **
**      use for reporting to the data collector.                      **
**      It then opens a udp connection for registering, registers,    **
**      and closes the udp socket.                                    **
**                                                                    **
************************************************************************
*/
    if  ((retcd = hbm_register(*argv, 0, NULL,NULL)) < 0)
    {
        return retcd;
    }
/*
************************************************************************
**  End of code for registering with the Heartbeat Monitor.           **
************************************************************************
*/

    while (time_curr.tv_sec <= time_end.tv_sec)
    {
        fprintf(stderr, "time remaining: %ld seconds\n",
                time_end.tv_sec-time_curr.tv_sec );
        sleep((unsigned int) 5);
        for (array_idx = 0; array_idx < array_idx_max; array_idx++)
            array_wk[array_idx] = array_idx_max - array_idx;
        gettimeofday(&time_curr, NULL);
    }


/*
************************************************************************
**  Include the following code to shutdown (un-register) with the     **
**  heartbeat monitor.                                                **
**                                                                    **
**  Definition of hbm_shutdown is as follows:                         **
**                                                                    **
**  int  hbm_shutdown(shutdown_mode)                                  **
**                                                                    **
**  Parameters:                                                       **
**      char  *procname - pointer to char,                            **
**                        (command line fields:                       **
**                            program name and parameters)            **
**                        program name is used when generating        **
**                        error messages.                             **
**                        (Error messages have format:                **
**                            "<pgm name>: HBM: <error description>"  **
**      unsigned int                                                  **
**            flags     - Logical OR of 0 with the following flags    **
**                        as appropriate (i.e., parms passed in,      **
**                        normally not used)                          **
**                        flags are:    HBM_CLFLAG_SET_CL_PID         **
**                                      HBM_CLFLAG_SET_CL_RPTNAME     **
**                                      HBM_CLFLAG_SET_DC_HOST        **
**                                      HBM_CLFLAG_SET_DC_PORT        **
**      struct hbm_parms                                              **
**            hbm_info  - struct with four fields to be used if       **
**                        corresponding flag is set:                  **
**                            int     cl_pid                          **
**                            char   *cl_procname_rpt                 **
**                            char   *dc_hostname                     **
**                            int     dc_port                         **
**      char  shutdown_mode  -  char code, should be one of the       **
**                          following:                                **
**                              HBM_MSGTYPE_SHUTDOWN_NORMAL           **
**                                  (Indicates normal program         **
**                                   termination)                     **
**                              HBM_MSGTYPE_SHUTDOWN_ABNORMAL         **
**                                  (Indicates abnormal program       **
**                                   termination)                     **
**                                                                    **
**          field usage is as follows:                                **
**              cl_pid:          pid of (different) process to        **
**                               unregister                           **
**              cl_procname_rpt: ignored                              **
**              dc_hostname:     ignored                              **
**              dc_port:         ignored                              **
**                                                                    **
**  Returned values:                                                  **
**      hbm_shutdown() returns an integer return code.                **
**          Successful completion:   = 0.                             **
**          Unsuccessful completion: < 0.                             **
**                                                                    **
**  Operation:                                                        **
**      hbm_shutdown() opens a udp connection for unregistering with  **
**      the Local Monitor, formats and sends the unregistration       **
**      message, closes the udp sockets, and exits.                   **
**                                                                    **
************************************************************************
*/
    if  (hbm_shutdown(*argv, 0, NULL, HBM_MSGTYPE_SHUTDOWN_NORMAL))
    {
        fprintf(stderr,
                "\n%s: Error on shutdown\n");
    }
/*
************************************************************************
**  End of code for unregistering with the Heartbeat Monitor.         **
************************************************************************
*/

    fprintf(stdout,
            "\n%s: Done\n",
            *argv);

}
