/*
************************************************************************
**                                                                    **
**  hbm_cllm.h - include file for HBM Clients and Local Monitors      **
**                                                                    **
************************************************************************
*/
#ifndef HBM_CLLM_H
#define HBM_CLLM_H

char    hbparm_fname_str[HBM_PARM_FNAME_LEN_MAX + 1] = "hbcparms";

int     hbm_sock_fd_hbm_hb;

u_long  hbm_hb_interval,
        hbm_hb_number;

struct sockaddr_in
        hbm_cli_addr_cmd,
        hbm_cli_addr_hb;

struct hostent
       *hbm_host_entry_ptr;

/*
**  Heartbeat client registration message length field and buffer.
**  The client registration message format is:
**      hbm_msg_RegCmsgLength   message length
**                              4 byte unsigned big-endian integer (UBEI)
**      hbm_msg_RegCmsgType     char (1 byte)
**      hbm_msg_RegCprocessName process name
**                              char[]      null-terminated string
**      hbm_msg_RegCprocessPID  process ID of client process
**                              4 byte UBEI
**      hbm_msg_RegCDChostIPNum IP address of HBMDC
**                              char[]      null-terminated string
**                                          (format: xxx.xxx.xxx.xxx)
**      hbm_msg_RegCDCportNum   Port Number for HBMLM to use when
**                                  reporting to HBMDC
**                              4 byte UBEI
*/

char   *hbm_msg_RegCmsg;

/*  literal "HBMCL" is first  */

u_long  hbm_msg_RegCmsgLength;
char   *hbm_msg_RegCmsgLength_ptr;

char   *hbm_msg_RegCmsgType_ptr;

char   *hbm_msg_RegCprocessPID_ptr;

char   *hbm_msg_RegCprocessName_str;

char   *hbm_msg_RegCprocessNameRpt_str;

char   *hbm_msg_RegCDChostIPNum_str;

char   *hbm_msg_RegCDCportNum_ptr;

u_long  hbm_msg_RegCmsgResp_len = 10;
char    hbm_msg_RegCmsgResp[10];

char    hbm_msg_array[1024];

u_long  hbm_msg_client_unreg_len;
char    hbm_msg_client_unreg[1024];

/*
**  Heartbeat client unregistration message length field and buffer.
**  The client unregistration message format is:
**      hbm_msg_UnRegCmsgLength   message length
**                                4 byte unsigned big-endian integer (UBEI)
**      hbm_msg_UnRegCmsgType     char (1 byte)
**      hbm_msg_UnRegCprocessName process name
**                                char[]      null-terminated string
**      hbm_msg_UnRegCprocessPID  process ID of client process
**                                4 byte UBEI
*/

#define HBM_LMTOCL_RESPONSE_MSGLENGTH  10

char   *hbm_msg_UnRegCmsg;

/*  literal "HBMCL" is first  */

u_long  hbm_msg_UnRegCmsgLength;
char   *hbm_msg_UnRegCmsgLength_ptr;

char   *hbm_msg_UnRegCmsgType_ptr;

char   *hbm_msg_UnRegCprocessPID_ptr;

char   *hbm_msg_UnRegCprocessName_str;


#endif /* HBM_CLLM_H */
/*
************************************************************************
**                                                                    **
**  hbm_cllm.h - end                                                  **
**                                                                    **
************************************************************************
*/
