/*
************************************************************************
**                                                                    **
**  hbm_codes.h - include file for heartbeat codes and flag values    **
**                                                                    **
************************************************************************
*/
#ifndef HBM_CODES_H
#define HBM_CODES_H

#define HBM_CLFLAG_SET_CL_PID               1
#define HBM_CLFLAG_SET_CL_RPTNAME           2
#define HBM_CLFLAG_SET_DC_HOSTNAME          4
#define HBM_CLFLAG_SET_DC_HOSTIPNUM         8
#define HBM_CLFLAG_SET_DC_PORT              16

#define HBM_HOSTREACHABLE_MINVAL            (u_long) 0
#define HBM_HOSTREACHABLE_NO                (u_long) 0
#define HBM_HOSTREACHABLE_YES_HB_MSG        (u_long) 1
#define HBM_HOSTREACHABLE_YES_PING          (u_long) 2
#define HBM_HOSTREACHABLE_PINGPENDING       (u_long) 3
#define HBM_HOSTREACHABLE_MAXVAL            (u_long) 3

#define HBM_MSGTYPE_REGISTER                '0'
#define HBM_MSGTYPE_RESPONSE_REGISTER       '1'
#define HBM_MSGTYPE_SHUTDOWN_NORMAL         '6'
#define HBM_MSGTYPE_SHUTDOWN_ABNORMAL       '7'
#define HBM_MSGTYPE_RESPONSE_SHUTDOWN       '8'

#define HBM_PORT_MIN_AVAILABLE              (u_short) 1024
#define HBM_PORT_MAX_AVAILABLE              (u_short) 65535

#define HBM_LMSTATUS_CLIENTS_UNKNOWN        0
#define HBM_LMSTATUS_CLIENTS_ACTIVE_ALL     1
#define HBM_LMSTATUS_CLIENTS_ACTIVE_SOME    2
#define HBM_LMSTATUS_CLIENTS_BLOCKED        3
#define HBM_LMSTATUS_CLIENTS_LATE_SOME      4
#define HBM_LMSTATUS_CLIENTS_LATE_ALL       5
#define HBM_LMSTATUS_CLIENTS_NONE_LIVE      9

#define HBM_PROCSTATUS_MINVAL               (u_long) 0
#define HBM_PROCSTATUS_UNKNOWN              (u_long) 0
#define HBM_PROCSTATUS_ACTIVE               (u_long) 1
#define HBM_PROCSTATUS_BLOCKED              (u_long) 2
#define HBM_PROCSTATUS_OVERDUE              (u_long) 3
#define HBM_PROCSTATUS_SHUTDOWN_NORMAL      (u_long) 4
#define HBM_PROCSTATUS_SHUTDOWN_ABNORMAL    (u_long) 5
#define HBM_PROCSTATUS_SHUTDOWN_DIED        (u_long) 6
#define HBM_PROCSTATUS_SHUTDOWN_NO_RPT      (u_long) 7
#define HBM_PROCSTATUS_MAXVAL               (u_long) 7

#define HBM_PROP_DELAY_ALLOWANCE            (u_long)  20
#define HBM_PROP_VARY_ALLOWANCE             (u_long)  2

#endif /* not defined HBM_CODES_H */
/*
************************************************************************
**                                                                    **
**  hbm_codes.h - end                                                 **
**                                                                    **
************************************************************************
*/
