/*
************************************************************************
**                                                                    **
**  hbm_common.h - HBM CL, LM, and DC common routines                 **
**                                                                    **
************************************************************************
*/
#ifndef HBM_COMMON_H
#define HBM_COMMON_H

/*
************************************************************************
**                                                                    **
**  hbm_get_IPNum_fr_name                                             **
**                                                                    **
************************************************************************
*/
int     hbm_get_IPNum_fr_name(  struct in_addr     *host_addr_ptr,
                                char               *hostname_in_str,
                                char              **hostname_out_str_ptr)
{
    struct hostent         *hostent_ptr;

#ifdef  HAVE_GETHOSTBYNAME_R_5
    int     error;
    struct hostent          hostent_result;

    char                   *buffer_ptr;
    int                     buffer_len = HBM_BUFF_SIZE_HOSTENT;

#elif (defined HAVE_GETHOSTBYNAME_R_3)
    int     error;
    struct hostent          hostent_result;

    struct hostent_data    *hostent_buff_ptr;

#endif  /*  HAVE_GETHOSTBYNAME_R_x  */

#ifdef HAVE_GETHOSTBYNAME_R_5

    bzero(&hostent_result, sizeof(hostent_result));

    buffer_ptr = (char *) malloc(HBM_BUFF_SIZE_HOSTENT);
    error = 0;
    hostent_ptr = gethostbyname_r(hostname_in_str,
                                  &hostent_result,
                                  buffer_ptr,
                                  buffer_len,
                                  &error);

#elif (defined HAVE_GETHOSTBYNAME_R_3)
    bzero(&hostent_result, sizeof(hostent_result));

    hostent_buff_ptr = (struct hostent_data *) malloc(sizeof(struct hostent_data));

    bzero(hostent_buff_ptr, sizeof(struct hostent_data));

    error = gethostbyname_r(hostname_in_str,
                            &hostent_result,
                            hostent_buff_ptr);

    if  (error)
    {
        hostent_ptr = NULL;
    }
    else
    {
        hostent_ptr = &hostent_result;
    }

#else

    hostent_ptr = gethostbyname(hostname_in_str);

#endif  /*  HAVE_GETHOSTBYNAME_R_x  */

    if  (hostent_ptr)
    {
        host_addr_ptr->s_addr =
                (((struct in_addr *)(*(hostent_ptr->h_addr_list)))->s_addr);
        if  (hostname_out_str_ptr)
        {
            if  (*hostname_out_str_ptr)
            {
                free(*hostname_out_str_ptr);
            }
            *hostname_out_str_ptr =
                                (char *) malloc(strlen(hostent_ptr->h_name) + 1);
            strcpy(*hostname_out_str_ptr, hostent_ptr->h_name);
        }
    }
    else
    {
        host_addr_ptr->s_addr = 0;
    }

#ifdef HAVE_GETHOSTBYNAME_R_5

    free(buffer_ptr);

#elif (defined HAVE_GETHOSTBYNAME_R_3)

    free(hostent_buff_ptr);

#endif  /*  HAVE_GETHOSTBYNAME_R_x  */

    if  (hostent_ptr)
    {
        return 0;
    }

    return -1;
}


/*
************************************************************************
**  hbm_read_line -- read fd until \n (up to (max-1));                **
**                   replace \n with \0;                              **
**                   return #char read                                **
**  This will work for now; we can do something better later.         **
************************************************************************
*/
int     hbm_read_line(  int     fd,
                        char   *buf,
                        int     max)
{
    int     cnt = 0,
            nbytes;

    max--;

    while (nbytes = read(fd, buf, 1))
    {
        if  (nbytes < 0)
        {
            return -1;
        }
        cnt++;
        if  (*buf == '\n')
        {
            break;
        }
        if  (cnt == max)
        {
            buf++;
            break;
        }
        buf++;
    }

    *buf = '\0';
    return cnt;
}

#endif /* HBM_COMMON_H */
/*
************************************************************************
**                                                                    **
**  hbm_cllm.h - end                                                  **
**                                                                    **
************************************************************************
*/
