/*
************************************************************************
**                                                                    **
**  hbm_defaults.h - include file for heartbeat default values        **
**                   and limit fields                                 **
**                                                                    **
************************************************************************
*/
#ifndef HBM_DEFAULTS_H
#define HBM_DEFAULTS_H

#define HBM_BUFF_SIZE_CKPT              1024
#define HBM_BUFF_SIZE_HOSTENT           4096
#define HBM_BUFF_SIZE_MSG               1024
#define HBM_BUFF_SIZE_PARM              512
#define HBM_BUFF_SIZE_PS                1024

#define HBM_DATE_TIME_LEN               64

#define HBM_IP_ADDRESS_SIZE             17

#define HBM_PARM_FNAME_LEN_MAX          256

#define HBM_PORT_MIN_AVAILABLE          (u_short) 1024
#define HBM_PORT_MAX_AVAILABLE          (u_short) 65535

#define HBM_TIME_SECS_PER_MIN           60
#define HBM_TIME_SECS_PER_HOUR          3600
#define HBM_TIME_SECS_PER_DAY           86400

#define HBMCL_REG_UNREG_ATTEMPT_MAX     5

#define HBMDC_DEFAULT_PORT_HBMSG        (u_short) 12003
#define HBMDC_DEFAULT_MONITOR_INTERVAL  15

#ifndef HBMDC_DEFAULT_CHKPTFILE
#define HBMDC_DEFAULT_CHKPTFILE         "SYSCONFDIR" "/hbmdc_checkpoint"
#endif /*  HBMDC_DEFAULT_CHKPTFILE  */
#ifndef HBMDC_DEFAULT_CONFIGFILE
#define HBMDC_DEFAULT_CONFIGFILE        "SYSCONFDIR" "/hbmdc.conf"
#endif /*  HBMDC_DEFAULT_CONFIGFILE  */
#ifndef HBMDC_DEFAULT_TRACEFILE
#define HBMDC_DEFAULT_TRACEFILE         "/dev/null"
#endif

#define HBMDC_LIM_MONITOR_INTERVAL_MIN  (u_long)  5
#define HBMDC_LIM_MONITOR_INTERVAL_MAX  (u_long)  3600

#define HBMDC_MSG_DELAY_OVERDUE         (u_long)  5
#define HBMDC_MSG_NUM_OVERDUE_SHUTDOWN  (u_long)  10

/*  Keep shutdown client info for 12 hours (12*60*60 = 43200)  */
#define HBMDC_CL_SHUTDOWN_RETENTION_SECS    43200

#define HBMDC_THRESHOLD_NOMSG           (u_long)  4
#define HBMDC_THRESHOLD_MSG_VARY        (u_long)  20*

#ifndef HBMLM_DEFAULT_CHKPTFILE
#define HBMLM_DEFAULT_CHKPTFILE         "SYSCONFDIR" "/hbmlm_checkpoint"
#endif /*  HBMLM_DEFAULT_CHKPTFILE  */

#define HBMLM_DEFAULT_PORT_REG          (u_short) 12001
#define HBMLM_DEFAULT_PORT_RPT          (u_short) 12002
#define HBMLM_DEFAULT_RPT_INTERVAL      15

#define HBMLM_LIM_REPORT_INTERVAL_MIN   (u_long)  2
#define HBMLM_LIM_REPORT_INTERVAL_MAX   (u_long)  3600

#endif /* HBM_DEFAULTS_H */
/*
************************************************************************
**                                                                    **
**  hbm_defaults.h - end                                              **
**                                                                    **
************************************************************************
*/
