/*****************************************************************/
/*      code_generator.h                                         */
/*      Version 1.0                      Henri Casanova          */
/*---------------------------------------------------------------*/
/*****************************************************************/

#include <stdio.h>
#include "server.h"

/* Macros definitions */

#define DEF_FILE "fortran.h"
#define DEF_HEADER "def_header"
#define HEADER "header"
#define PHEADER "pheader"
#define TARGET "numerical"
#define TARGETMAKEFILE "Makefile.numerical"
#define TARGETINITCODE "problem_init.c"
#define MNEMONIC_LENGTH 5  /* For instance 'mI212' */

#define PVM 1
#define MPI 2
#define MPL 3
#define NX  4

/*
 * Global variables
 */ 

int  condorserver;

FILE *target_def;
FILE *target_makefile;
FILE *sourcefile;
FILE *targetfile;
int linecount;
char line[MAX_LINE_LENGTH];
static int *PARALLEL;

#define C_NAME  "C"
#define F_NAME  "FORTRAN"
#define C       0
#define F       1

problem_desc *pb_desc;
int current_language;

static char *function_name[10];
int problemcount;

char *root;

#ifdef __STDC__

int generate_makefile(int,char**,char**,int,int*);
int process_code();
int process_line();
char *process_mnemonic(int,char*,int*);
int check_mnemonic_list(char**,int);
int lookup(char**,char*);
int check_mnemonic(char*);
int check_expression(char*,char**,int);
int get_op_arg1_arg2(char*,char**,char**,char**);
int get_array_index(char*,char**,char**);
int get_members(char*,char**,char**,char**,char**);
int is_number(char*);
int write_line(char*);
int put_header();
int put_header_def();
char *read_line();
int caps(char*,char*);
int uppercase(char*);

#else
int generate_makefile();
int process_code();
int process_line();
char *process_mnemonic();
int check_mnemonic_list();
int lookup();
int check_mnemonic();
int check_expression();
int get_op_arg1_arg2();
int get_array_index();
int get_members();
int is_number();
int write_line();
int put_header();
int put_header_def();
char *read_line();
int caps();
int uppercase();


#endif
