/****************************************************************/
/*      prototypes.h                                            */
/*      Version 0.0                      Henri Casanova         */
/****************************************************************/

/* SERVER */

#ifdef __STDC__
int linear_algebra(problem_desc*,input_sizes*,input_sizes*,void**,void**);

int pcompute(problem_desc*,input_sizes*,input_sizes*,void**,
            void**,int,int,char*,int);
int compute(problem_desc*,input_sizes*,input_sizes*,void**,
            void**,int,int,char*,int);
int kflops();
#define REAL double
int matgen(REAL[],int,int,REAL[],REAL*);
int dgefa(REAL[],int,int,int[],int*);
int dgesl(REAL[],int,int,int[],REAL[],int);
int daxpy(int,REAL,REAL[],int,REAL[],int);
REAL ddot(int,REAL[],int,REAL[],int);
int dscal(int,REAL,REAL[],int);
int idamax(int,REAL[],int);
REAL epslon(REAL);
int dmxpy(int,REAL[],int,int,REAL[],REAL[]);
REAL seconds();

int *desc_init(int,int,int);
int Cnumroc(int,int,int,int,int);
void Cpdtran(int,int,double,double*,int,int,int*,double,double*,int,int,int*);
int *make_ipiv(int);
int para_term();

int transpose_matrix(int,int,void**,int,int);

int problem_init();
int restriction_included(restriction_item*,int,restriction_item*,int);
int restriction_contains(restriction_item*,int,restriction_item);
int item_contains(char*,char*);
int get_restriction_group(int);
int set_CONDOR(char*);
int setMPI(char*);
int set_number_processors(char*);
int set_master(char*);
int set_restrictions(char*);

int gen_pb_refused(int);
int proc_mes();
int my_speed();
int server_init();
int contact_master(char*,char);
int get_all_struct();
int check_security(char*,char*);
int is_unsafe(char*);
int are_undefined(char*);
int create_done_file(char*,int);
void workload_death(int);
void workload_handler(int);
int run_workload_process();
int my_workload();
#ifdef PLAT_SGI64
char *mystrstr(char*,char*);
#endif

#else
int transpose_matrix();
int linear_algebra();
int pcompute();
int *desc_init();
int para_term();
int Cnumroc();
void Cpdtran();
int *make_ipiv();
int compute();
int kflops();
#define REAL double
int matgen();
int dgefa();
int dgesl();
int daxpy();
REAL ddot();
int dscal();
int idamax();
REAL epslon();
int dmxpy();
REAL seconds();
int problem_init();
int restriction_included();
int restriction_contains();
int item_contains();
int get_restriction_group();
int set_CONDOR();
int setMPI();
int set_number_processors();
int set_master();
int set_restrictions();
int gen_pb_refused();
int proc_mes();
int my_speed();
int server_init();
int contact_master();
int get_all_struct();
int check_security();
int is_unsafe();
int are_undefined();
int create_done_file();
void workload_death();
void workload_handler();
int run_workload_process();
int my_workload();
#ifdef PLAT_SGI64
char *mystrstr();
#endif

#endif
