/****************************************************************/
/*      prototypes.h                                            */
/*      Version 0.0                      Henri Casanova         */
/****************************************************************/

/* SHARED */

#ifdef __STDC__

int gen_sv_failure(int);
int gen_failure_report(time_t,unsigned int);
int gen_distance_report(unsigned int,int,int);
int poll_gen_pb_list(int,int);
int poll_gen_sv_list(int,int);
int poll_gen_get_pb();
int poll_gen_get_sv();
int poll_gen_stat();
int uppercase(char*);
int lowecase(char*);
int hash_sv(unsigned int);
int hash_pb(char*);
server_item *new_server_item(unsigned int);
server_item *new_agent_item(unsigned int);
problem_item *new_problem_item(char*);
int add_server_to_pb(problem_item*,server_item*);
int add_pb_to_server(problem_item*,server_item*);
problem_item *find_problem(char*);
server_item **give_server_list(problem_item*,int*);
server_item *find_server(unsigned int);
server_item *find_agent(unsigned int);
problem_item *new_problem(problem_desc);
server_item *new_server(server_desc);
server_item *new_agent(server_desc);
int remove_server(server_item*);
int remove_agent(server_item*);
int Print_cache(int);
int new_server_log();
int new_agent_log();
int set_server_log();
int new_log(char*);
int set_date();
int add_request_to_log(int);
int append_to_log(char*);
int log_truncate();
int log_term();
int free_pb_desc(problem_desc*);
int arch_to_format(char*);
int is_number(char*);
int tread(int,char*,int);
int init_send(int,int);
int init_recv(int);
int end_message();
int end_com();
int xdr_scomplex(XDR*,scomplex*);
int xdr_dcomplex(XDR*,dcomplex*);
int read_string(char*);
int read_int(int *);
int read_char_array(char*,int);
int read_int_array(int*,int);
int read_IPaddr(unsigned int*);
int read_long(long*);
int read_single_array(float*,int);
int read_double_array(double*,int);
int read_u_char_array(unsigned char*,int);
int read_scomplex_array(scomplex*,int);
int read_dcomplex_array(dcomplex*,int);
int write_string(char*);
int write_int(int*);
int write_int_array(int*,int);
int write_char_array(char*,int);
int write_IPaddr(unsigned int*);
int write_long(long*);
int write_single_array(float*,int);
int write_byte_array(void*,int);
int read_byte_array(void*,int);
int write_double_array(double*,int);
int write_u_char_array(unsigned char*,int);
int write_scomplex_array(scomplex*,int);
int write_dcomplex_array(dcomplex*,int);
int read_char_array_file(int,int);
int read_int_array_file(int,int);
int read_single_array_file(int,int);
int read_double_array_file(int,int);
int read_scomplex_array_file(int,int);
int read_dcomplex_array_file(int,int);
int write_char_array_file(int,int);
int write_int_array_file(int,int);
int write_single_array_file(int,int);
int write_double_array_file(int,int);
int write_scomplex_array_file(int,int);
int write_dcomplex_array_file(int,int);
int write_problem(problem_desc);
int read_problem(problem_desc *);
int problem_cmp(problem_desc,problem_desc);
int problem_cmp_format(problem_desc,problem_desc);
int arg_list_cmp(char*,char*);
int power(int,int);
char *read_line(FILE*,char*,int*);
int establish_socket(int*);
int connect_to_agent(char*,int);
int connect_to_server(char*,int);
int connect_to_socket(char*,unsigned int,int);
void set_signals();
void term();
int clean_up();
void evilsig(int);
void catch(int);
#ifdef SIGDANGER
void biteme(int);
#endif
void reap(int);
int data_format();
int bailout();
int distance_request(int,server_item*,int);
int is_there_comp_pid();
int new_comp_pid(int,int);
int remove_comp_pid(int);

#else

int gen_sv_failure();
int gen_failure_report();
int gen_distance_report();
int poll_gen_pb_list();
int poll_gen_sv_list();
int poll_gen_get_pb();
int poll_gen_get_sv();
int poll_gen_stat();
int uppercase();
int lowecase();
int hash_sv();
int hash_pb();
server_item *new_server_item();
server_item *new_agent_item();
problem_item *new_problem_item();
int add_server_to_pb();
int add_pb_to_server();
problem_item *find_problem();
server_item **give_server_list();
server_item *find_server();
server_item *find_agent();
problem_item *new_problem();
server_item *new_server();
server_item *new_agent();
int remove_server();
int remove_agent();
int Print_cache();
int new_server_log();
int new_agent_log();
int set_server_log();
int new_log();
int set_date();
int add_request_to_log();
int append_to_log();
int log_truncate();
int log_term();
int free_pb_desc();
int arch_to_format();
int is_number();
int tread();
int init_send();
int init_recv();
int end_message();
int end_com();
int xdr_scomplex();
int xdr_dcomplex();
int read_string();
int read_int();
int read_char_array();
int read_int_array();
int read_IPaddr();
int read_long();
int read_single_array();
int read_double_array();
int read_u_char_array();
int read_scomplex_array();
int read_dcomplex_array();
int write_string();
int write_int();
int write_int_array();
int write_char_array();
int write_IPaddr();
int write_long();
int write_single_array();
int write_double_array();
int write_u_char_array();
int write_scomplex_array();
int write_dcomplex_array();
int read_char_array_file();
int read_int_array_file();
int read_single_array_file();
int read_double_array_file();
int read_scomplex_array_file();
int read_dcomplex_array_file();
int write_char_array_file();
int write_int_array_file();
int write_single_array_file();
int write_double_array_file();
int write_scomplex_array_file();
int write_dcomplex_array_file();
int write_problem();
int read_problem();
int problem_cmp();
int problem_cmp_format();
int arg_list_cmp();
int power();
char *read_line();
int establish_socket();
int connect_to_agent();
int connect_to_server();
int connect_to_socket();
void set_signals();
void term();
int clean_up();
void evilsig();
void catch();
#ifdef SIGDANGER
void biteme();
#endif
void reap();
int data_format();
int bailout();
int distance_request();
int is_there_comp_pid();
int new_comp_pid();
int remove_comp_pid();
#endif
