/*****************************************************************/
/*      code_util.c                                              */
/*      Version 1.0                      Henri Casanova          */
/*---------------------------------------------------------------*/
/* is_number()                                                   */
/* write_line()                                                  */
/* put_header()                                                  */
/* put_header_def()                                              */
/* read_line()                                                   */
/* caps()                                                        */
/* uppercase()                                                   */
/*****************************************************************/

#include "code_generator.h"

/*
 * is_number()
 *
 * given a string, return 0 if the string is an integer, -1 otherwise
 */
#ifdef __STDC__
int is_number(char *string)
#else
int is_number(string)
char *string;
#endif
{
  int i=0;

  while ((string[i] != '\0')&&(string[i] != '\n'))
  {
    if ((string[i]<'0')||(string[i]>'9'))
      return -1;
    i++;
  }
  return 0;
}

/*
 * write_line()
 *
 */

#ifdef __STDC__
int write_line(char *string)
#else
int write_line(string)
char *string;
#endif
{
  return (fwrite(string,1,strlen(string),targetfile));
}

/*
 * put_header
 *
 * put the header at the beginning of the file
 *
 */
#ifdef __STDC__
int put_header()
#else
int put_header()
#endif
{
  FILE *headerfile;
  char name[256];

  sprintf(name,"%s/src/CodeGenerator/%s\0",root,HEADER);
  headerfile = fopen(name,"r");
  if (headerfile == NULL)
  {
    fprintf(stderr,"Impossible to open the header file : %s\n",name);
    exit(0);
  }
  while(fgets(line,MAX_LINE_LENGTH,headerfile) != NULL)
  {
    if (write_line(line) <0)
      return -1;
  }
  return 1;

}

/*
 * put_header_def()
 *
 * put the header at the beginning of the file
 *
 */
#ifdef __STDC__
int put_header_def()
#else
int put_header_def()
#endif
{
  FILE *headerfile;
  char name[256];

  sprintf(name,"%s/src/CodeGenerator/%s\0",root,DEF_HEADER);
  headerfile = fopen(name,"r");
  if (headerfile == NULL)
  {
    fprintf(stderr,"Impossible to open the header file : %s\n",name);
    exit(0);
  }
  while(fgets(line,MAX_LINE_LENGTH,headerfile) != NULL)
  {
    if ((fwrite(line,1,strlen(line),target_def)) <0)
      return -1;
  }
  return 1;

}

/*
 * read_line()
 *
 *   Read a line and skips empty line or comments
 *
 */

#ifdef __STDC__
char *read_line()
#else
char *read_line()
#endif
{
  char *tmp = NULL;

  do 
  {
    tmp = fgets(line,MAX_LINE_LENGTH,sourcefile);
    if (tmp == NULL) 
      break;
    linecount++;
  } while((tmp[0] == '\n')||(tmp[0] == '#'));
  return tmp;
}

/*
 * caps()
 *
 * returns the capsed string
 */

#ifdef __STDC__
int caps(char *dest,char *source)
#else
int caps(dest,source)
char *dest;
char *source;
#endif
{
  int i;

  for (i=0;i<strlen(source)+1;i++)
    dest[i] = toupper(source[i]);

  return 1;
}

/*
 * uppercase() : change a string in uppercase
 */
#ifdef __STDC__
int uppercase(char *string)
#else
int uppercase(string)
char *string;
#endif
{
  int length,i;

  length = strlen(string);
  for (i=0;i<length;i++)
    if ((string[i] >= 97)&&(string[i]<=122))
      string[i] = string[i]-32;
}
