/************************************************************************
 * stat_comm.c
 * July 1997 for communication of netsolve statistics
 * Kim Buckner
 *-----------------------------------------------------------------------
 * This is the routine to communicate the statistics from the server
 * and agent process to UTK.  This will use port number XXXX on
 * yyyy.cs.utk.edu as the primary, wwww.cs.utk.edu as the secondary and
 * zzzz.cs.utk.edu as the last alternative.  One of these should be available
 * unless there is a general network failure.  
 * The idea here is for the log_file routines to rename the logfile to 
 * oldlog.'time' where time is the last 6 digits of the current time.  If this 
 * fails it will repeat twice then fail.  This will probably mean that the
 * process cannot create the new file because of space or permissions.  Oh
 * well.  Assuming that the rename works, then it will open the new file, fork
 * and close the new file then return.  The child will then exec this routine
 * which will attempt to establish the socket and transmit the file.  If 
 * successful it will remove the file and exit.  If not successful, it will
 * sleep then try again.  This will continue for 24 hours then expire
 * unfulfilled and delete the file.  This will not reinvent the wheel but
 * use the socket/network functions that Henri Casanova has already set up. 
 ***********************************************************************/
#include "global.h"
#include "address.h"
#include <fcntl.h>


main(argc, argv)
int argc;
char **argv;
{
  int log,sock;
  int i;
  int rtn;
  char f_buf[256];
  time_t start,current;

  exit(0);
  if(argc!=2) {
#ifdef VIEW
    fprintf(stderr,"Incorrect number of arguments to stat_comm -%d\n",argc);
#endif
    exit(1);
    }

  if((log=open(argv[1],O_RDONLY))<0) {
#ifdef VIEW
    fprintf(stderr,"Stat_comm could not open file %s, sleeping\n",argv[1]);
#endif
    sleep(5);
    if((log=open(argv[1],O_RDONLY))<0) {
#ifdef VIEW
      fprintf(stderr,"Stat_comm could not open file %s, exiting\n",argv[1]);
#endif
      exit(1);
      }
    }
  close(log); /*the file exists for now so I will try to send it but it might
		take a while so I close it and reopen later*/
  time(&start); 
  start=start+(24*60*60); /*add 24 hours*/
  current=0;
  while(start>current) {
    i=0; 
    while(((sock=connect_to_socket(HOME_NAME[i],HOME_IP[i],HOME_PORT))<0) 
      && (i<3)) i++;
    if(sock<0) { /*could not connect*/
      sleep(600); /*10 minutes*/
      }
    else { /*I connected*/
      if((log=open(argv[1],O_RDONLY))<0) {
#ifdef VIEW
        fprintf(stderr,"Stat_comm could not open file %s\n",argv[1]);
#endif
        exit(1);
        }
      while((rtn=read(log,f_buf,256))>0) {
	write(sock,f_buf,rtn);
	}
      close(log);
      close(sock);
      remove(argv[1]);
      exit(0);
      }
    time(&current);
  }
  /*time expired and no connection so exit and erase the file*/
  remove(argv[1]);
  exit(0);
}
       

