/*****************************************************************/
/*      is_there_agent.c                                         */
/*      Version 1.0                      Henri Casanova          */
/*---------------------------------------------------------------*/
/*  main()                                                       */
/*****************************************************************/

#include "global.h"

main(argc,argv)
int argc;
char **argv;
{
  int sock;                            /* socket descriptor            */
  struct sockaddr_in server_add;       /* Server INET address */
  struct hostent *hp;
  int message_type;
  int answer;
  int status=-1;

  if (argv[1] == NULL)
  {
    fprintf(stdout,"Usage : %s <agent name>\n",argv[0]);
    exit(0);
  }

  if ((sock =socket(AF_INET,SOCK_STREAM,0)) == -1)
  {
    perror("socket()");
    exit(1);
  }
    BZERO(&server_add,sizeof(server_add));
  if ((hp = gethostbyname(argv[1])) == NULL)
  {
    fprintf(stdout,"'%s' unreachable\n",argv[1]);
    return -1;
  }
  BCOPY(hp->h_addr,&server_add.sin_addr,hp->h_length);
  server_add.sin_family = AF_INET;
  server_add.sin_port = htons(AG_PORT);

/*
 * connect to the server socket.
 */
  if (connect(sock,(struct sockaddr *)&server_add,sizeof(server_add)) == -1)
  {
    end_com();
    fprintf(stdout,"None\n");
    exit(0);
  }
  /* Always XDR */
  init_send(DATA_XDR,sock);
  message_type = ARE_YOU_ALIVE;
  write_int(&message_type);
  end_message();

  /* Receive the data */
  init_recv(sock);
  read_int(&answer);
  end_message();
  end_com();

  if (answer == ALIVE)
  {
    fprintf(stdout,"Agent\n");
    exit(0);
  }
  fprintf(stdout,"None\n");
  exit(0);

}

